#ifndef ALAKZAT_H_INCLUDED
#define ALAKZAT_H_INCLUDED

#include "alakzatos.hpp"

/*
 * A legfontosabb osztály: becsomagol egy heterogén alakzatot
 * (egyetlen egy darabot) és érték szerint másolhatóvá teszi.
 */
class Alakzat {
    private:
        AlakzatOs * a;
    
    public:
        explicit Alakzat(AlakzatOs * a) : a(a) {}
        Alakzat(Alakzat const & masolando) {
            a = masolando.a->masol();
        }
        Alakzat& operator=(Alakzat const & masolando) {
            if (this != &masolando) {
                delete a;
                a = masolando.a->masol();
            }
            return *this;
        }
        ~Alakzat() {
            delete a;
        }
        AlakzatOs * operator->() {
            return a;
        }
        AlakzatOs const * operator->() const {
            return a;
        }
        AlakzatOs & operator*() {
            return *a;
        }
        AlakzatOs const & operator*() const {
            return *a;
        }
};

#endif // ALAKZAT_H_INCLUDED
