#ifndef POLIGON_HPP_INCLUDED
#define POLIGON_HPP_INCLUDED

#include <stdexcept>
#include <vector>
#include "alakzat.hpp"

class Poligon : public AlakzatOs {
    std::vector<Point> pontok;      // csucspontok, p0-hoz kepest relativan

public:
    Poligon(Color sz, std::vector<Point> pontok)
        : AlakzatOs(Point(0, 0), sz)
        , pontok(pontok)            // a p0 kezdetben az origo, igy nem kell relativva alakitani
    {
    }

    size_t getnp() const { return pontok.size(); }

    Point getcsp(size_t i) const {
        return pontok.at(i);
    }

    void rajzol() {
        std::vector<Point> temp(pontok.size());
        for (int i = 0; i < pontok.size(); ++i)
            temp[i] = pontok[i] + p0;
        sokszog_rajzol(temp, sz);
    }
    
    virtual AlakzatOs * masol() const {
        return new Poligon(*this);
    }
};

/// Globális << operátor
std::ostream& operator<<(std::ostream&, const Poligon&);

#endif // POLIGON_H
